// Code generated by girgen. DO NOT EDIT.

package gdk

import (
	"fmt"
	"runtime"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/core/gextras"
	externglib "github.com/diamondburned/gotk4/pkg/core/glib"
)

// #cgo pkg-config: gtk4
// #cgo CFLAGS: -Wno-deprecated-declarations
// #include <gdk/gdk.h>
// #include <glib-object.h>
import "C"

func init() {
	externglib.RegisterGValueMarshalers([]externglib.TypeMarshaler{
		{T: externglib.Type(C.gdk_crossing_mode_get_type()), F: marshalCrossingMode},
		{T: externglib.Type(C.gdk_event_type_get_type()), F: marshalEventType},
		{T: externglib.Type(C.gdk_key_match_get_type()), F: marshalKeyMatch},
		{T: externglib.Type(C.gdk_notify_type_get_type()), F: marshalNotifyType},
		{T: externglib.Type(C.gdk_scroll_direction_get_type()), F: marshalScrollDirection},
		{T: externglib.Type(C.gdk_touchpad_gesture_phase_get_type()), F: marshalTouchpadGesturePhase},
		{T: externglib.Type(C.gdk_button_event_get_type()), F: marshalButtonEventer},
		{T: externglib.Type(C.gdk_crossing_event_get_type()), F: marshalCrossingEventer},
		{T: externglib.Type(C.gdk_dnd_event_get_type()), F: marshalDNDEventer},
		{T: externglib.Type(C.gdk_delete_event_get_type()), F: marshalDeleteEventer},
		{T: externglib.Type(C.gdk_event_get_type()), F: marshalEventer},
		{T: externglib.Type(C.gdk_focus_event_get_type()), F: marshalFocusEventer},
		{T: externglib.Type(C.gdk_grab_broken_event_get_type()), F: marshalGrabBrokenEventer},
		{T: externglib.Type(C.gdk_key_event_get_type()), F: marshalKeyEventer},
		{T: externglib.Type(C.gdk_motion_event_get_type()), F: marshalMotionEventer},
		{T: externglib.Type(C.gdk_pad_event_get_type()), F: marshalPadEventer},
		{T: externglib.Type(C.gdk_proximity_event_get_type()), F: marshalProximityEventer},
		{T: externglib.Type(C.gdk_scroll_event_get_type()), F: marshalScrollEventer},
		{T: externglib.Type(C.gdk_touch_event_get_type()), F: marshalTouchEventer},
		{T: externglib.Type(C.gdk_touchpad_event_get_type()), F: marshalTouchpadEventer},
		{T: externglib.Type(C.gdk_event_sequence_get_type()), F: marshalEventSequence},
	})
}

// BUTTON_MIDDLE: middle button.
const BUTTON_MIDDLE = 2

// BUTTON_PRIMARY: primary button. This is typically the left mouse button, or
// the right button in a left-handed setup.
const BUTTON_PRIMARY = 1

// BUTTON_SECONDARY: secondary button. This is typically the right mouse button,
// or the left button in a left-handed setup.
const BUTTON_SECONDARY = 3

// EVENT_PROPAGATE: use this macro as the return value for continuing the
// propagation of an event handler.
const EVENT_PROPAGATE = false

// EVENT_STOP: use this macro as the return value for stopping the propagation
// of an event handler.
const EVENT_STOP = true

// PRIORITY_REDRAW: this is the priority that the idle handler processing
// surface updates is given in the main loop.
const PRIORITY_REDRAW = 120

// CrossingMode specifies the crossing mode for enter and leave events.
type CrossingMode int

const (
	// CrossingNormal: crossing because of pointer motion.
	CrossingNormal CrossingMode = iota
	// CrossingGrab: crossing because a grab is activated.
	CrossingGrab
	// CrossingUngrab: crossing because a grab is deactivated.
	CrossingUngrab
	// CrossingGTKGrab: crossing because a GTK grab is activated.
	CrossingGTKGrab
	// CrossingGTKUngrab: crossing because a GTK grab is deactivated.
	CrossingGTKUngrab
	// CrossingStateChanged: crossing because a GTK widget changed state (e.g.
	// sensitivity).
	CrossingStateChanged
	// CrossingTouchBegin: crossing because a touch sequence has begun, this
	// event is synthetic as the pointer might have not left the surface.
	CrossingTouchBegin
	// CrossingTouchEnd: crossing because a touch sequence has ended, this event
	// is synthetic as the pointer might have not left the surface.
	CrossingTouchEnd
	// CrossingDeviceSwitch: crossing because of a device switch (i.e. a mouse
	// taking control of the pointer after a touch device), this event is
	// synthetic as the pointer didn’t leave the surface.
	CrossingDeviceSwitch
)

func marshalCrossingMode(p uintptr) (interface{}, error) {
	return CrossingMode(C.g_value_get_enum((*C.GValue)(unsafe.Pointer(p)))), nil
}

// String returns the name in string for CrossingMode.
func (c CrossingMode) String() string {
	switch c {
	case CrossingNormal:
		return "Normal"
	case CrossingGrab:
		return "Grab"
	case CrossingUngrab:
		return "Ungrab"
	case CrossingGTKGrab:
		return "GTKGrab"
	case CrossingGTKUngrab:
		return "GTKUngrab"
	case CrossingStateChanged:
		return "StateChanged"
	case CrossingTouchBegin:
		return "TouchBegin"
	case CrossingTouchEnd:
		return "TouchEnd"
	case CrossingDeviceSwitch:
		return "DeviceSwitch"
	default:
		return fmt.Sprintf("CrossingMode(%d)", c)
	}
}

// EventType specifies the type of the event.
type EventType int

const (
	// Delete: window manager has requested that the toplevel surface be hidden
	// or destroyed, usually when the user clicks on a special icon in the title
	// bar.
	Delete EventType = iota
	// MotionNotify: pointer (usually a mouse) has moved.
	MotionNotify
	// ButtonPress: mouse button has been pressed.
	ButtonPress
	// ButtonRelease: mouse button has been released.
	ButtonRelease
	// KeyPress: key has been pressed.
	KeyPress
	// KeyRelease: key has been released.
	KeyRelease
	// EnterNotify: pointer has entered the surface.
	EnterNotify
	// LeaveNotify: pointer has left the surface.
	LeaveNotify
	// FocusChange: keyboard focus has entered or left the surface.
	FocusChange
	// ProximityIn: input device has moved into contact with a sensing surface
	// (e.g. a touchscreen or graphics tablet).
	ProximityIn
	// ProximityOut: input device has moved out of contact with a sensing
	// surface.
	ProximityOut
	// DragEnter: mouse has entered the surface while a drag is in progress.
	DragEnter
	// DragLeave: mouse has left the surface while a drag is in progress.
	DragLeave
	// DragMotion: mouse has moved in the surface while a drag is in progress.
	DragMotion
	// DropStart: drop operation onto the surface has started.
	DropStart
	// Scroll: scroll wheel was turned.
	Scroll
	// GrabBroken: pointer or keyboard grab was broken.
	GrabBroken
	// TouchBegin: new touch event sequence has just started.
	TouchBegin
	// TouchUpdate: touch event sequence has been updated.
	TouchUpdate
	// TouchEnd: touch event sequence has finished.
	TouchEnd
	// TouchCancel: touch event sequence has been canceled.
	TouchCancel
	// TouchpadSwipe: touchpad swipe gesture event, the current state is
	// determined by its phase field.
	TouchpadSwipe
	// TouchpadPinch: touchpad pinch gesture event, the current state is
	// determined by its phase field.
	TouchpadPinch
	// PadButtonPress: tablet pad button press event.
	PadButtonPress
	// PadButtonRelease: tablet pad button release event.
	PadButtonRelease
	// PadRing: tablet pad axis event from a "ring".
	PadRing
	// PadStrip: tablet pad axis event from a "strip".
	PadStrip
	// PadGroupMode: tablet pad group mode change.
	PadGroupMode
	// EventLast marks the end of the GdkEventType enumeration.
	EventLast
)

func marshalEventType(p uintptr) (interface{}, error) {
	return EventType(C.g_value_get_enum((*C.GValue)(unsafe.Pointer(p)))), nil
}

// String returns the name in string for EventType.
func (e EventType) String() string {
	switch e {
	case Delete:
		return "Delete"
	case MotionNotify:
		return "MotionNotify"
	case ButtonPress:
		return "ButtonPress"
	case ButtonRelease:
		return "ButtonRelease"
	case KeyPress:
		return "KeyPress"
	case KeyRelease:
		return "KeyRelease"
	case EnterNotify:
		return "EnterNotify"
	case LeaveNotify:
		return "LeaveNotify"
	case FocusChange:
		return "FocusChange"
	case ProximityIn:
		return "ProximityIn"
	case ProximityOut:
		return "ProximityOut"
	case DragEnter:
		return "DragEnter"
	case DragLeave:
		return "DragLeave"
	case DragMotion:
		return "DragMotion"
	case DropStart:
		return "DropStart"
	case Scroll:
		return "Scroll"
	case GrabBroken:
		return "GrabBroken"
	case TouchBegin:
		return "TouchBegin"
	case TouchUpdate:
		return "TouchUpdate"
	case TouchEnd:
		return "TouchEnd"
	case TouchCancel:
		return "TouchCancel"
	case TouchpadSwipe:
		return "TouchpadSwipe"
	case TouchpadPinch:
		return "TouchpadPinch"
	case PadButtonPress:
		return "PadButtonPress"
	case PadButtonRelease:
		return "PadButtonRelease"
	case PadRing:
		return "PadRing"
	case PadStrip:
		return "PadStrip"
	case PadGroupMode:
		return "PadGroupMode"
	case EventLast:
		return "EventLast"
	default:
		return fmt.Sprintf("EventType(%d)", e)
	}
}

// KeyMatch describes how well an event matches a given keyval and modifiers.
//
// GdkKeyMatch values are returned by gdk.KeyEvent.Matches().
type KeyMatch int

const (
	// KeyMatchNone: key event does not match.
	KeyMatchNone KeyMatch = iota
	// KeyMatchPartial: key event matches if keyboard state (specifically, the
	// currently active group) is ignored.
	KeyMatchPartial
	// KeyMatchExact: key event matches.
	KeyMatchExact
)

func marshalKeyMatch(p uintptr) (interface{}, error) {
	return KeyMatch(C.g_value_get_enum((*C.GValue)(unsafe.Pointer(p)))), nil
}

// String returns the name in string for KeyMatch.
func (k KeyMatch) String() string {
	switch k {
	case KeyMatchNone:
		return "None"
	case KeyMatchPartial:
		return "Partial"
	case KeyMatchExact:
		return "Exact"
	default:
		return fmt.Sprintf("KeyMatch(%d)", k)
	}
}

// NotifyType specifies the kind of crossing for enter and leave events.
//
// See the X11 protocol specification of LeaveNotify for full details of
// crossing event generation.
type NotifyType int

const (
	// NotifyAncestor: surface is entered from an ancestor or left towards an
	// ancestor.
	NotifyAncestor NotifyType = iota
	// NotifyVirtual: pointer moves between an ancestor and an inferior of the
	// surface.
	NotifyVirtual
	// NotifyInferior: surface is entered from an inferior or left towards an
	// inferior.
	NotifyInferior
	// NotifyNonlinear: surface is entered from or left towards a surface which
	// is neither an ancestor nor an inferior.
	NotifyNonlinear
	// NotifyNonlinearVirtual: pointer moves between two surfaces which are not
	// ancestors of each other and the surface is part of the ancestor chain
	// between one of these surfaces and their least common ancestor.
	NotifyNonlinearVirtual
	// NotifyUnknown: unknown type of enter/leave event occurred.
	NotifyUnknown
)

func marshalNotifyType(p uintptr) (interface{}, error) {
	return NotifyType(C.g_value_get_enum((*C.GValue)(unsafe.Pointer(p)))), nil
}

// String returns the name in string for NotifyType.
func (n NotifyType) String() string {
	switch n {
	case NotifyAncestor:
		return "Ancestor"
	case NotifyVirtual:
		return "Virtual"
	case NotifyInferior:
		return "Inferior"
	case NotifyNonlinear:
		return "Nonlinear"
	case NotifyNonlinearVirtual:
		return "NonlinearVirtual"
	case NotifyUnknown:
		return "Unknown"
	default:
		return fmt.Sprintf("NotifyType(%d)", n)
	}
}

// ScrollDirection specifies the direction for scroll events.
type ScrollDirection int

const (
	// ScrollUp: surface is scrolled up.
	ScrollUp ScrollDirection = iota
	// ScrollDown: surface is scrolled down.
	ScrollDown
	// ScrollLeft: surface is scrolled to the left.
	ScrollLeft
	// ScrollRight: surface is scrolled to the right.
	ScrollRight
	// ScrollSmooth: scrolling is determined by the delta values in scroll
	// events. See gdk_scroll_event_get_deltas().
	ScrollSmooth
)

func marshalScrollDirection(p uintptr) (interface{}, error) {
	return ScrollDirection(C.g_value_get_enum((*C.GValue)(unsafe.Pointer(p)))), nil
}

// String returns the name in string for ScrollDirection.
func (s ScrollDirection) String() string {
	switch s {
	case ScrollUp:
		return "Up"
	case ScrollDown:
		return "Down"
	case ScrollLeft:
		return "Left"
	case ScrollRight:
		return "Right"
	case ScrollSmooth:
		return "Smooth"
	default:
		return fmt.Sprintf("ScrollDirection(%d)", s)
	}
}

// TouchpadGesturePhase specifies the current state of a touchpad gesture.
//
// All gestures are guaranteed to begin with an event with phase
// GDK_TOUCHPAD_GESTURE_PHASE_BEGIN, followed by 0 or several events with phase
// GDK_TOUCHPAD_GESTURE_PHASE_UPDATE.
//
// A finished gesture may have 2 possible outcomes, an event with phase
// GDK_TOUCHPAD_GESTURE_PHASE_END will be emitted when the gesture is considered
// successful, this should be used as the hint to perform any permanent changes.
//
// Cancelled gestures may be so for a variety of reasons, due to hardware or the
// compositor, or due to the gesture recognition layers hinting the gesture did
// not finish resolutely (eg. a 3rd finger being added during a pinch gesture).
// In these cases, the last event will report the phase
// GDK_TOUCHPAD_GESTURE_PHASE_CANCEL, this should be used as a hint to undo any
// visible/permanent changes that were done throughout the progress of the
// gesture.
type TouchpadGesturePhase int

const (
	// TouchpadGesturePhaseBegin: gesture has begun.
	TouchpadGesturePhaseBegin TouchpadGesturePhase = iota
	// TouchpadGesturePhaseUpdate: gesture has been updated.
	TouchpadGesturePhaseUpdate
	// TouchpadGesturePhaseEnd: gesture was finished, changes should be
	// permanently applied.
	TouchpadGesturePhaseEnd
	// TouchpadGesturePhaseCancel: gesture was cancelled, all changes should be
	// undone.
	TouchpadGesturePhaseCancel
)

func marshalTouchpadGesturePhase(p uintptr) (interface{}, error) {
	return TouchpadGesturePhase(C.g_value_get_enum((*C.GValue)(unsafe.Pointer(p)))), nil
}

// String returns the name in string for TouchpadGesturePhase.
func (t TouchpadGesturePhase) String() string {
	switch t {
	case TouchpadGesturePhaseBegin:
		return "Begin"
	case TouchpadGesturePhaseUpdate:
		return "Update"
	case TouchpadGesturePhaseEnd:
		return "End"
	case TouchpadGesturePhaseCancel:
		return "Cancel"
	default:
		return fmt.Sprintf("TouchpadGesturePhase(%d)", t)
	}
}

// EventsGetAngle returns the relative angle from event1 to event2.
//
// The relative angle is the angle between the X axis and the line through both
// events' positions. The rotation direction for positive angles is from the
// positive X axis towards the positive Y axis.
//
// This assumes that both events have X/Y information. If not, this function
// returns FALSE.
func EventsGetAngle(event1 Eventer, event2 Eventer) (float64, bool) {
	var _arg1 *C.GdkEvent // out
	var _arg2 *C.GdkEvent // out
	var _arg3 C.double    // in
	var _cret C.gboolean  // in

	_arg1 = (*C.GdkEvent)(unsafe.Pointer(event1.Native()))
	_arg2 = (*C.GdkEvent)(unsafe.Pointer(event2.Native()))

	_cret = C.gdk_events_get_angle(_arg1, _arg2, &_arg3)
	runtime.KeepAlive(event1)
	runtime.KeepAlive(event2)

	var _angle float64 // out
	var _ok bool       // out

	_angle = float64(_arg3)
	if _cret != 0 {
		_ok = true
	}

	return _angle, _ok
}

// EventsGetCenter returns the point halfway between the events' positions.
//
// This assumes that both events have X/Y information. If not, this function
// returns FALSE.
func EventsGetCenter(event1 Eventer, event2 Eventer) (x float64, y float64, ok bool) {
	var _arg1 *C.GdkEvent // out
	var _arg2 *C.GdkEvent // out
	var _arg3 C.double    // in
	var _arg4 C.double    // in
	var _cret C.gboolean  // in

	_arg1 = (*C.GdkEvent)(unsafe.Pointer(event1.Native()))
	_arg2 = (*C.GdkEvent)(unsafe.Pointer(event2.Native()))

	_cret = C.gdk_events_get_center(_arg1, _arg2, &_arg3, &_arg4)
	runtime.KeepAlive(event1)
	runtime.KeepAlive(event2)

	var _x float64 // out
	var _y float64 // out
	var _ok bool   // out

	_x = float64(_arg3)
	_y = float64(_arg4)
	if _cret != 0 {
		_ok = true
	}

	return _x, _y, _ok
}

// EventsGetDistance returns the distance between the event locations.
//
// This assumes that both events have X/Y information. If not, this function
// returns FALSE.
func EventsGetDistance(event1 Eventer, event2 Eventer) (float64, bool) {
	var _arg1 *C.GdkEvent // out
	var _arg2 *C.GdkEvent // out
	var _arg3 C.double    // in
	var _cret C.gboolean  // in

	_arg1 = (*C.GdkEvent)(unsafe.Pointer(event1.Native()))
	_arg2 = (*C.GdkEvent)(unsafe.Pointer(event2.Native()))

	_cret = C.gdk_events_get_distance(_arg1, _arg2, &_arg3)
	runtime.KeepAlive(event1)
	runtime.KeepAlive(event2)

	var _distance float64 // out
	var _ok bool          // out

	_distance = float64(_arg3)
	if _cret != 0 {
		_ok = true
	}

	return _distance, _ok
}

// ButtonEvent: event related to a button on a pointer device.
type ButtonEvent struct {
	Event
}

func wrapButtonEvent(obj *externglib.Object) *ButtonEvent {
	return &ButtonEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalButtonEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapButtonEvent(obj), nil
}

// Button: extract the button number from a button event.
func (event *ButtonEvent) Button() uint {
	var _arg0 *C.GdkEvent // out
	var _cret C.guint     // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_button_event_get_button(_arg0)
	runtime.KeepAlive(event)

	var _guint uint // out

	_guint = uint(_cret)

	return _guint
}

// CrossingEvent: event caused by a pointing device moving between surfaces.
type CrossingEvent struct {
	Event
}

func wrapCrossingEvent(obj *externglib.Object) *CrossingEvent {
	return &CrossingEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalCrossingEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapCrossingEvent(obj), nil
}

// Detail extracts the notify detail from a crossing event.
func (event *CrossingEvent) Detail() NotifyType {
	var _arg0 *C.GdkEvent     // out
	var _cret C.GdkNotifyType // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_crossing_event_get_detail(_arg0)
	runtime.KeepAlive(event)

	var _notifyType NotifyType // out

	_notifyType = NotifyType(_cret)

	return _notifyType
}

// Focus checks if the event surface is the focus surface.
func (event *CrossingEvent) Focus() bool {
	var _arg0 *C.GdkEvent // out
	var _cret C.gboolean  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_crossing_event_get_focus(_arg0)
	runtime.KeepAlive(event)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Mode extracts the crossing mode from a crossing event.
func (event *CrossingEvent) Mode() CrossingMode {
	var _arg0 *C.GdkEvent       // out
	var _cret C.GdkCrossingMode // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_crossing_event_get_mode(_arg0)
	runtime.KeepAlive(event)

	var _crossingMode CrossingMode // out

	_crossingMode = CrossingMode(_cret)

	return _crossingMode
}

// DNDEvent: event related to drag and drop operations.
type DNDEvent struct {
	Event
}

func wrapDNDEvent(obj *externglib.Object) *DNDEvent {
	return &DNDEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalDNDEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapDNDEvent(obj), nil
}

// Drop gets the GdkDrop object from a DND event.
func (event *DNDEvent) Drop() Dropper {
	var _arg0 *C.GdkEvent // out
	var _cret *C.GdkDrop  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_dnd_event_get_drop(_arg0)
	runtime.KeepAlive(event)

	var _drop Dropper // out

	if _cret != nil {
		{
			objptr := unsafe.Pointer(_cret)

			object := externglib.Take(objptr)
			rv, ok := (externglib.CastObject(object)).(Dropper)
			if !ok {
				panic("object of type " + object.TypeFromInstance().String() + " is not gdk.Dropper")
			}
			_drop = rv
		}
	}

	return _drop
}

// DeleteEvent: event related to closing a top-level surface.
type DeleteEvent struct {
	Event
}

func wrapDeleteEvent(obj *externglib.Object) *DeleteEvent {
	return &DeleteEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalDeleteEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapDeleteEvent(obj), nil
}

func (*DeleteEvent) privateDeleteEvent() {}

// Event GdkEvents are immutable data structures, created by GDK to represent
// windowing system events.
//
// In GTK applications the events are handled automatically by toplevel widgets
// and passed on to the event controllers of appropriate widgets, so using
// GdkEvent and its related API is rarely needed.
type Event struct {
	*externglib.Object
}

// Eventer describes Event's abstract methods.
type Eventer interface {
	externglib.Objector

	// Axes extracts all axis values from an event.
	Axes() ([]float64, bool)
	// Axis: extract the axis value for a particular axis use from an event
	// structure.
	Axis(axisUse AxisUse) (float64, bool)
	// Device returns the device of an event.
	Device() Devicer
	// DeviceTool returns a GdkDeviceTool representing the tool that caused the
	// event.
	DeviceTool() *DeviceTool
	// Display retrieves the display associated to the event.
	Display() *Display
	// EventSequence retuns the event sequence to which the event belongs.
	EventSequence() *EventSequence
	// EventType retrieves the type of the event.
	EventType() EventType
	// History retrieves the history of the device that event is for, as a list
	// of time and coordinates.
	History() []TimeCoord
	// ModifierState returns the modifier state field of an event.
	ModifierState() ModifierType
	// PointerEmulated returns whether this event is an 'emulated' pointer
	// event.
	PointerEmulated() bool
	// Position: extract the event surface relative x/y coordinates from an
	// event.
	Position() (x float64, y float64, ok bool)
	// Seat returns the seat that originated the event.
	Seat() Seater
	// Surface extracts the surface associated with an event.
	Surface() Surfacer
	// Time returns the timestamp of event.
	Time() uint32
	// TriggersContextMenu returns whether a GdkEvent should trigger a context
	// menu, according to platform conventions.
	TriggersContextMenu() bool
}

var _ Eventer = (*Event)(nil)

func wrapEvent(obj *externglib.Object) *Event {
	return &Event{
		Object: obj,
	}
}

func marshalEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapEvent(obj), nil
}

// Axes extracts all axis values from an event.
func (event *Event) Axes() ([]float64, bool) {
	var _arg0 *C.GdkEvent // out
	var _arg1 *C.double   // in
	var _arg2 C.guint     // in
	var _cret C.gboolean  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_axes(_arg0, &_arg1, &_arg2)
	runtime.KeepAlive(event)

	var _axes []float64 // out
	var _ok bool        // out

	_axes = make([]float64, _arg2)
	copy(_axes, unsafe.Slice((*float64)(unsafe.Pointer(_arg1)), _arg2))
	if _cret != 0 {
		_ok = true
	}

	return _axes, _ok
}

// Axis: extract the axis value for a particular axis use from an event
// structure.
func (event *Event) Axis(axisUse AxisUse) (float64, bool) {
	var _arg0 *C.GdkEvent  // out
	var _arg1 C.GdkAxisUse // out
	var _arg2 C.double     // in
	var _cret C.gboolean   // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))
	_arg1 = C.GdkAxisUse(axisUse)

	_cret = C.gdk_event_get_axis(_arg0, _arg1, &_arg2)
	runtime.KeepAlive(event)
	runtime.KeepAlive(axisUse)

	var _value float64 // out
	var _ok bool       // out

	_value = float64(_arg2)
	if _cret != 0 {
		_ok = true
	}

	return _value, _ok
}

// Device returns the device of an event.
func (event *Event) Device() Devicer {
	var _arg0 *C.GdkEvent  // out
	var _cret *C.GdkDevice // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_device(_arg0)
	runtime.KeepAlive(event)

	var _device Devicer // out

	if _cret != nil {
		{
			objptr := unsafe.Pointer(_cret)

			object := externglib.Take(objptr)
			rv, ok := (externglib.CastObject(object)).(Devicer)
			if !ok {
				panic("object of type " + object.TypeFromInstance().String() + " is not gdk.Devicer")
			}
			_device = rv
		}
	}

	return _device
}

// DeviceTool returns a GdkDeviceTool representing the tool that caused the
// event.
//
// If the was not generated by a device that supports different tools (such as a
// tablet), this function will return NULL.
//
// Note: the GdkDeviceTool will be constant during the application lifetime, if
// settings must be stored persistently across runs, see
// gdk.DeviceTool.GetSerial().
func (event *Event) DeviceTool() *DeviceTool {
	var _arg0 *C.GdkEvent      // out
	var _cret *C.GdkDeviceTool // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_device_tool(_arg0)
	runtime.KeepAlive(event)

	var _deviceTool *DeviceTool // out

	if _cret != nil {
		_deviceTool = wrapDeviceTool(externglib.Take(unsafe.Pointer(_cret)))
	}

	return _deviceTool
}

// Display retrieves the display associated to the event.
func (event *Event) Display() *Display {
	var _arg0 *C.GdkEvent   // out
	var _cret *C.GdkDisplay // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_display(_arg0)
	runtime.KeepAlive(event)

	var _display *Display // out

	if _cret != nil {
		_display = wrapDisplay(externglib.Take(unsafe.Pointer(_cret)))
	}

	return _display
}

// EventSequence retuns the event sequence to which the event belongs.
//
// Related touch events are connected in a sequence. Other events typically
// don't have event sequence information.
func (event *Event) EventSequence() *EventSequence {
	var _arg0 *C.GdkEvent         // out
	var _cret *C.GdkEventSequence // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_event_sequence(_arg0)
	runtime.KeepAlive(event)

	var _eventSequence *EventSequence // out

	_eventSequence = (*EventSequence)(gextras.NewStructNative(unsafe.Pointer(_cret)))

	return _eventSequence
}

// EventType retrieves the type of the event.
func (event *Event) EventType() EventType {
	var _arg0 *C.GdkEvent    // out
	var _cret C.GdkEventType // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_event_type(_arg0)
	runtime.KeepAlive(event)

	var _eventType EventType // out

	_eventType = EventType(_cret)

	return _eventType
}

// History retrieves the history of the device that event is for, as a list of
// time and coordinates.
//
// The history includes positions that are not delivered as separate events to
// the application because they occurred in the same frame as event.
//
// Note that only motion and scroll events record history, and motion events do
// it only if one of the mouse buttons is down.
func (event *Event) History() []TimeCoord {
	var _arg0 *C.GdkEvent     // out
	var _cret *C.GdkTimeCoord // in
	var _arg1 C.guint         // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_history(_arg0, &_arg1)
	runtime.KeepAlive(event)

	var _timeCoords []TimeCoord // out

	if _cret != nil {
		defer C.free(unsafe.Pointer(_cret))
		{
			src := unsafe.Slice(_cret, _arg1)
			_timeCoords = make([]TimeCoord, _arg1)
			for i := 0; i < int(_arg1); i++ {
				_timeCoords[i] = *(*TimeCoord)(gextras.NewStructNative(unsafe.Pointer((&src[i]))))
			}
		}
	}

	return _timeCoords
}

// ModifierState returns the modifier state field of an event.
func (event *Event) ModifierState() ModifierType {
	var _arg0 *C.GdkEvent       // out
	var _cret C.GdkModifierType // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_modifier_state(_arg0)
	runtime.KeepAlive(event)

	var _modifierType ModifierType // out

	_modifierType = ModifierType(_cret)

	return _modifierType
}

// PointerEmulated returns whether this event is an 'emulated' pointer event.
//
// Emulated pointer events typically originate from a touch events.
func (event *Event) PointerEmulated() bool {
	var _arg0 *C.GdkEvent // out
	var _cret C.gboolean  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_pointer_emulated(_arg0)
	runtime.KeepAlive(event)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Position: extract the event surface relative x/y coordinates from an event.
func (event *Event) Position() (x float64, y float64, ok bool) {
	var _arg0 *C.GdkEvent // out
	var _arg1 C.double    // in
	var _arg2 C.double    // in
	var _cret C.gboolean  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_position(_arg0, &_arg1, &_arg2)
	runtime.KeepAlive(event)

	var _x float64 // out
	var _y float64 // out
	var _ok bool   // out

	_x = float64(_arg1)
	_y = float64(_arg2)
	if _cret != 0 {
		_ok = true
	}

	return _x, _y, _ok
}

// Seat returns the seat that originated the event.
func (event *Event) Seat() Seater {
	var _arg0 *C.GdkEvent // out
	var _cret *C.GdkSeat  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_seat(_arg0)
	runtime.KeepAlive(event)

	var _seat Seater // out

	if _cret != nil {
		{
			objptr := unsafe.Pointer(_cret)

			object := externglib.Take(objptr)
			rv, ok := (externglib.CastObject(object)).(Seater)
			if !ok {
				panic("object of type " + object.TypeFromInstance().String() + " is not gdk.Seater")
			}
			_seat = rv
		}
	}

	return _seat
}

// Surface extracts the surface associated with an event.
func (event *Event) Surface() Surfacer {
	var _arg0 *C.GdkEvent   // out
	var _cret *C.GdkSurface // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_surface(_arg0)
	runtime.KeepAlive(event)

	var _surface Surfacer // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type gdk.Surfacer is nil")
		}

		object := externglib.Take(objptr)
		rv, ok := (externglib.CastObject(object)).(Surfacer)
		if !ok {
			panic("object of type " + object.TypeFromInstance().String() + " is not gdk.Surfacer")
		}
		_surface = rv
	}

	return _surface
}

// Time returns the timestamp of event.
//
// Not all events have timestamps. In that case, this function returns
// GDK_CURRENT_TIME.
func (event *Event) Time() uint32 {
	var _arg0 *C.GdkEvent // out
	var _cret C.guint32   // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_get_time(_arg0)
	runtime.KeepAlive(event)

	var _guint32 uint32 // out

	_guint32 = uint32(_cret)

	return _guint32
}

// TriggersContextMenu returns whether a GdkEvent should trigger a context menu,
// according to platform conventions.
//
// The right mouse button typically triggers context menus.
//
// This function should always be used instead of simply checking for
// event->button == GDK_BUTTON_SECONDARY.
func (event *Event) TriggersContextMenu() bool {
	var _arg0 *C.GdkEvent // out
	var _cret C.gboolean  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_event_triggers_context_menu(_arg0)
	runtime.KeepAlive(event)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// FocusEvent: event related to a keyboard focus change.
type FocusEvent struct {
	Event
}

func wrapFocusEvent(obj *externglib.Object) *FocusEvent {
	return &FocusEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalFocusEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapFocusEvent(obj), nil
}

// In extracts whether this event is about focus entering or leaving the
// surface.
func (event *FocusEvent) In() bool {
	var _arg0 *C.GdkEvent // out
	var _cret C.gboolean  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_focus_event_get_in(_arg0)
	runtime.KeepAlive(event)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// GrabBrokenEvent: event related to a broken windowing system grab.
type GrabBrokenEvent struct {
	Event
}

func wrapGrabBrokenEvent(obj *externglib.Object) *GrabBrokenEvent {
	return &GrabBrokenEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalGrabBrokenEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapGrabBrokenEvent(obj), nil
}

// GrabSurface extracts the grab surface from a grab broken event.
func (event *GrabBrokenEvent) GrabSurface() Surfacer {
	var _arg0 *C.GdkEvent   // out
	var _cret *C.GdkSurface // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_grab_broken_event_get_grab_surface(_arg0)
	runtime.KeepAlive(event)

	var _surface Surfacer // out

	{
		objptr := unsafe.Pointer(_cret)
		if objptr == nil {
			panic("object of type gdk.Surfacer is nil")
		}

		object := externglib.Take(objptr)
		rv, ok := (externglib.CastObject(object)).(Surfacer)
		if !ok {
			panic("object of type " + object.TypeFromInstance().String() + " is not gdk.Surfacer")
		}
		_surface = rv
	}

	return _surface
}

// Implicit checks whether the grab broken event is for an implicit grab.
func (event *GrabBrokenEvent) Implicit() bool {
	var _arg0 *C.GdkEvent // out
	var _cret C.gboolean  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_grab_broken_event_get_implicit(_arg0)
	runtime.KeepAlive(event)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// KeyEvent: event related to a key-based device.
type KeyEvent struct {
	Event
}

func wrapKeyEvent(obj *externglib.Object) *KeyEvent {
	return &KeyEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalKeyEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapKeyEvent(obj), nil
}

// ConsumedModifiers extracts the consumed modifiers from a key event.
func (event *KeyEvent) ConsumedModifiers() ModifierType {
	var _arg0 *C.GdkEvent       // out
	var _cret C.GdkModifierType // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_key_event_get_consumed_modifiers(_arg0)
	runtime.KeepAlive(event)

	var _modifierType ModifierType // out

	_modifierType = ModifierType(_cret)

	return _modifierType
}

// Keycode extracts the keycode from a key event.
func (event *KeyEvent) Keycode() uint {
	var _arg0 *C.GdkEvent // out
	var _cret C.guint     // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_key_event_get_keycode(_arg0)
	runtime.KeepAlive(event)

	var _guint uint // out

	_guint = uint(_cret)

	return _guint
}

// Keyval extracts the keyval from a key event.
func (event *KeyEvent) Keyval() uint {
	var _arg0 *C.GdkEvent // out
	var _cret C.guint     // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_key_event_get_keyval(_arg0)
	runtime.KeepAlive(event)

	var _guint uint // out

	_guint = uint(_cret)

	return _guint
}

// Layout extracts the layout from a key event.
func (event *KeyEvent) Layout() uint {
	var _arg0 *C.GdkEvent // out
	var _cret C.guint     // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_key_event_get_layout(_arg0)
	runtime.KeepAlive(event)

	var _guint uint // out

	_guint = uint(_cret)

	return _guint
}

// Level extracts the shift level from a key event.
func (event *KeyEvent) Level() uint {
	var _arg0 *C.GdkEvent // out
	var _cret C.guint     // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_key_event_get_level(_arg0)
	runtime.KeepAlive(event)

	var _guint uint // out

	_guint = uint(_cret)

	return _guint
}

// Match gets a keyval and modifier combination that will match the event.
//
// See gdk.KeyEvent.Matches().
func (event *KeyEvent) Match() (uint, ModifierType, bool) {
	var _arg0 *C.GdkEvent       // out
	var _arg1 C.guint           // in
	var _arg2 C.GdkModifierType // in
	var _cret C.gboolean        // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_key_event_get_match(_arg0, &_arg1, &_arg2)
	runtime.KeepAlive(event)

	var _keyval uint            // out
	var _modifiers ModifierType // out
	var _ok bool                // out

	_keyval = uint(_arg1)
	_modifiers = ModifierType(_arg2)
	if _cret != 0 {
		_ok = true
	}

	return _keyval, _modifiers, _ok
}

// IsModifier extracts whether the key event is for a modifier key.
func (event *KeyEvent) IsModifier() bool {
	var _arg0 *C.GdkEvent // out
	var _cret C.gboolean  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_key_event_is_modifier(_arg0)
	runtime.KeepAlive(event)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Matches a key event against a keyval and modifiers.
//
// This is typically used to trigger keyboard shortcuts such as Ctrl-C.
//
// Partial matches are possible where the combination matches if the currently
// active group is ignored.
//
// Note that we ignore Caps Lock for matching.
func (event *KeyEvent) Matches(keyval uint, modifiers ModifierType) KeyMatch {
	var _arg0 *C.GdkEvent       // out
	var _arg1 C.guint           // out
	var _arg2 C.GdkModifierType // out
	var _cret C.GdkKeyMatch     // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))
	_arg1 = C.guint(keyval)
	_arg2 = C.GdkModifierType(modifiers)

	_cret = C.gdk_key_event_matches(_arg0, _arg1, _arg2)
	runtime.KeepAlive(event)
	runtime.KeepAlive(keyval)
	runtime.KeepAlive(modifiers)

	var _keyMatch KeyMatch // out

	_keyMatch = KeyMatch(_cret)

	return _keyMatch
}

// MotionEvent: event related to a pointer or touch device motion.
type MotionEvent struct {
	Event
}

func wrapMotionEvent(obj *externglib.Object) *MotionEvent {
	return &MotionEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalMotionEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapMotionEvent(obj), nil
}

func (*MotionEvent) privateMotionEvent() {}

// PadEvent: event related to a pad-based device.
type PadEvent struct {
	Event
}

func wrapPadEvent(obj *externglib.Object) *PadEvent {
	return &PadEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalPadEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapPadEvent(obj), nil
}

// AxisValue extracts the information from a pad strip or ring event.
func (event *PadEvent) AxisValue() (uint, float64) {
	var _arg0 *C.GdkEvent // out
	var _arg1 C.guint     // in
	var _arg2 C.double    // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	C.gdk_pad_event_get_axis_value(_arg0, &_arg1, &_arg2)
	runtime.KeepAlive(event)

	var _index uint    // out
	var _value float64 // out

	_index = uint(_arg1)
	_value = float64(_arg2)

	return _index, _value
}

// Button extracts information about the pressed button from a pad event.
func (event *PadEvent) Button() uint {
	var _arg0 *C.GdkEvent // out
	var _cret C.guint     // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_pad_event_get_button(_arg0)
	runtime.KeepAlive(event)

	var _guint uint // out

	_guint = uint(_cret)

	return _guint
}

// GroupMode extracts group and mode information from a pad event.
func (event *PadEvent) GroupMode() (group uint, mode uint) {
	var _arg0 *C.GdkEvent // out
	var _arg1 C.guint     // in
	var _arg2 C.guint     // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	C.gdk_pad_event_get_group_mode(_arg0, &_arg1, &_arg2)
	runtime.KeepAlive(event)

	var _group uint // out
	var _mode uint  // out

	_group = uint(_arg1)
	_mode = uint(_arg2)

	return _group, _mode
}

// ProximityEvent: event related to the proximity of a tool to a device.
type ProximityEvent struct {
	Event
}

func wrapProximityEvent(obj *externglib.Object) *ProximityEvent {
	return &ProximityEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalProximityEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapProximityEvent(obj), nil
}

func (*ProximityEvent) privateProximityEvent() {}

// ScrollEvent: event related to a scrolling motion.
type ScrollEvent struct {
	Event
}

func wrapScrollEvent(obj *externglib.Object) *ScrollEvent {
	return &ScrollEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalScrollEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapScrollEvent(obj), nil
}

// Deltas extracts the scroll deltas of a scroll event.
//
// The deltas will be zero unless the scroll direction is GDK_SCROLL_SMOOTH.
func (event *ScrollEvent) Deltas() (deltaX float64, deltaY float64) {
	var _arg0 *C.GdkEvent // out
	var _arg1 C.double    // in
	var _arg2 C.double    // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	C.gdk_scroll_event_get_deltas(_arg0, &_arg1, &_arg2)
	runtime.KeepAlive(event)

	var _deltaX float64 // out
	var _deltaY float64 // out

	_deltaX = float64(_arg1)
	_deltaY = float64(_arg2)

	return _deltaX, _deltaY
}

// Direction extracts the direction of a scroll event.
func (event *ScrollEvent) Direction() ScrollDirection {
	var _arg0 *C.GdkEvent          // out
	var _cret C.GdkScrollDirection // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_scroll_event_get_direction(_arg0)
	runtime.KeepAlive(event)

	var _scrollDirection ScrollDirection // out

	_scrollDirection = ScrollDirection(_cret)

	return _scrollDirection
}

// IsStop: check whether a scroll event is a stop scroll event.
//
// Scroll sequences with smooth scroll information may provide a stop scroll
// event once the interaction with the device finishes, e.g. by lifting a
// finger. This stop scroll event is the signal that a widget may trigger
// kinetic scrolling based on the current velocity.
//
// Stop scroll events always have a delta of 0/0.
func (event *ScrollEvent) IsStop() bool {
	var _arg0 *C.GdkEvent // out
	var _cret C.gboolean  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_scroll_event_is_stop(_arg0)
	runtime.KeepAlive(event)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// TouchEvent: event related to a touch-based device.
type TouchEvent struct {
	Event
}

func wrapTouchEvent(obj *externglib.Object) *TouchEvent {
	return &TouchEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalTouchEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapTouchEvent(obj), nil
}

// EmulatingPointer extracts whether a touch event is emulating a pointer event.
func (event *TouchEvent) EmulatingPointer() bool {
	var _arg0 *C.GdkEvent // out
	var _cret C.gboolean  // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_touch_event_get_emulating_pointer(_arg0)
	runtime.KeepAlive(event)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// TouchpadEvent: event related to a gesture on a touchpad device.
//
// Unlike touchscreens, where the windowing system sends basic sequences of
// begin, update, end events, and leaves gesture recognition to the clients,
// touchpad gestures are typically processed by the system, resulting in these
// events.
type TouchpadEvent struct {
	Event
}

func wrapTouchpadEvent(obj *externglib.Object) *TouchpadEvent {
	return &TouchpadEvent{
		Event: Event{
			Object: obj,
		},
	}
}

func marshalTouchpadEventer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapTouchpadEvent(obj), nil
}

// Deltas extracts delta information from a touchpad event.
func (event *TouchpadEvent) Deltas() (dx float64, dy float64) {
	var _arg0 *C.GdkEvent // out
	var _arg1 C.double    // in
	var _arg2 C.double    // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	C.gdk_touchpad_event_get_deltas(_arg0, &_arg1, &_arg2)
	runtime.KeepAlive(event)

	var _dx float64 // out
	var _dy float64 // out

	_dx = float64(_arg1)
	_dy = float64(_arg2)

	return _dx, _dy
}

// GesturePhase extracts the touchpad gesture phase from a touchpad event.
func (event *TouchpadEvent) GesturePhase() TouchpadGesturePhase {
	var _arg0 *C.GdkEvent               // out
	var _cret C.GdkTouchpadGesturePhase // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_touchpad_event_get_gesture_phase(_arg0)
	runtime.KeepAlive(event)

	var _touchpadGesturePhase TouchpadGesturePhase // out

	_touchpadGesturePhase = TouchpadGesturePhase(_cret)

	return _touchpadGesturePhase
}

// NFingers extracts the number of fingers from a touchpad event.
func (event *TouchpadEvent) NFingers() uint {
	var _arg0 *C.GdkEvent // out
	var _cret C.guint     // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_touchpad_event_get_n_fingers(_arg0)
	runtime.KeepAlive(event)

	var _guint uint // out

	_guint = uint(_cret)

	return _guint
}

// PinchAngleDelta extracts the angle delta from a touchpad pinch event.
func (event *TouchpadEvent) PinchAngleDelta() float64 {
	var _arg0 *C.GdkEvent // out
	var _cret C.double    // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_touchpad_event_get_pinch_angle_delta(_arg0)
	runtime.KeepAlive(event)

	var _gdouble float64 // out

	_gdouble = float64(_cret)

	return _gdouble
}

// PinchScale extracts the scale from a touchpad pinch event.
func (event *TouchpadEvent) PinchScale() float64 {
	var _arg0 *C.GdkEvent // out
	var _cret C.double    // in

	_arg0 = (*C.GdkEvent)(unsafe.Pointer(event.Native()))

	_cret = C.gdk_touchpad_event_get_pinch_scale(_arg0)
	runtime.KeepAlive(event)

	var _gdouble float64 // out

	_gdouble = float64(_cret)

	return _gdouble
}

// EventSequence: GdkEventSequence is an opaque type representing a sequence of
// related touch events.
//
// An instance of this type is always passed by reference.
type EventSequence struct {
	*eventSequence
}

// eventSequence is the struct that's finalized.
type eventSequence struct {
	native *C.GdkEventSequence
}

func marshalEventSequence(p uintptr) (interface{}, error) {
	b := C.g_value_get_boxed((*C.GValue)(unsafe.Pointer(p)))
	return &EventSequence{&eventSequence{(*C.GdkEventSequence)(unsafe.Pointer(b))}}, nil
}
