// Code generated by girgen. DO NOT EDIT.

package gtk

import (
	"runtime"
	"unsafe"

	"github.com/diamondburned/gotk4/pkg/core/gerror"
	externglib "github.com/diamondburned/gotk4/pkg/core/glib"
	"github.com/diamondburned/gotk4/pkg/gdk/v4"
)

// #cgo pkg-config: gtk4
// #cgo CFLAGS: -Wno-deprecated-declarations
// #include <glib-object.h>
// #include <gtk/gtk.h>
import "C"

func init() {
	externglib.RegisterGValueMarshalers([]externglib.TypeMarshaler{
		{T: externglib.Type(C.gtk_media_stream_get_type()), F: marshalMediaStreamer},
	})
}

// MediaStreamOverrider contains methods that are overridable.
//
// As of right now, interface overriding and subclassing is not supported
// yet, so the interface currently has no use.
type MediaStreamOverrider interface {
	// Pause pauses playback of the stream.
	//
	// If the stream is not playing, do nothing.
	Pause()
	Play() bool
	// Realize: called by users to attach the media stream to a GdkSurface they
	// manage.
	//
	// The stream can then access the resources of surface for its rendering
	// purposes. In particular, media streams might want to create a
	// GdkGLContext or sync to the GdkFrameClock.
	//
	// Whoever calls this function is responsible for calling
	// gtk.MediaStream.Unrealize() before either the stream or surface get
	// destroyed.
	//
	// Multiple calls to this function may happen from different users of the
	// video, even with the same surface. Each of these calls must be followed
	// by its own call to gtk.MediaStream.Unrealize().
	//
	// It is not required to call this function to make a media stream work.
	Realize(surface gdk.Surfacer)
	// Seek: start a seek operation on self to timestamp.
	//
	// If timestamp is out of range, it will be clamped.
	//
	// Seek operations may not finish instantly. While a seek operation is in
	// process, the gtk.MediaStream:seeking property will be set.
	//
	// When calling gtk_media_stream_seek() during an ongoing seek operation,
	// the new seek will override any pending seek.
	Seek(timestamp int64)
	// Unrealize undoes a previous call to gtk_media_stream_realize().
	//
	// This causes the stream to release all resources it had allocated from
	// surface.
	Unrealize(surface gdk.Surfacer)
	UpdateAudio(muted bool, volume float64)
}

// MediaStream: GtkMediaStream is the integration point for media playback
// inside GTK.
//
// GTK provides an implementation of the GtkMediaStream interface that is called
// gtk.MediaFile.
//
// Apart from application-facing API for stream playback, GtkMediaStream has a
// number of APIs that are only useful for implementations and should not be
// used in applications: gtk.MediaStream.Prepared(),
// gtk.MediaStream.Unprepared(), gtk.MediaStream.Update(),
// gtk.MediaStream.Ended(), gtk.MediaStream.SeekSuccess(),
// gtk.MediaStream.SeekFailed(), gtk.MediaStream.GError(),
// gtk.MediaStream.Error(), gtk.MediaStream.ErrorValist().
type MediaStream struct {
	*externglib.Object

	gdk.Paintable
}

// MediaStreamer describes MediaStream's abstract methods.
type MediaStreamer interface {
	externglib.Objector

	// Ended pauses the media stream and marks it as ended.
	Ended()
	// GError sets self into an error state.
	GError(err error)
	// Duration gets the duration of the stream.
	Duration() int64
	// GetEnded returns whether the streams playback is finished.
	GetEnded() bool
	// Error: if the stream is in an error state, returns the GError explaining
	// that state.
	Error() error
	// Loop returns whether the stream is set to loop.
	Loop() bool
	// Muted returns whether the audio for the stream is muted.
	Muted() bool
	// Playing: return whether the stream is currently playing.
	Playing() bool
	// Timestamp returns the current presentation timestamp in microseconds.
	Timestamp() int64
	// Volume returns the volume of the audio for the stream.
	Volume() float64
	// HasAudio returns whether the stream has audio.
	HasAudio() bool
	// HasVideo returns whether the stream has video.
	HasVideo() bool
	// IsPrepared returns whether the stream has finished initializing.
	IsPrepared() bool
	// IsSeekable checks if a stream may be seekable.
	IsSeekable() bool
	// IsSeeking checks if there is currently a seek operation going on.
	IsSeeking() bool
	// Pause pauses playback of the stream.
	Pause()
	// Play starts playing the stream.
	Play()
	// Prepared: called by GtkMediaStream implementations to advertise the
	// stream being ready to play and providing details about the stream.
	Prepared(hasAudio bool, hasVideo bool, seekable bool, duration int64)
	// Realize: called by users to attach the media stream to a GdkSurface they
	// manage.
	Realize(surface gdk.Surfacer)
	// Seek: start a seek operation on self to timestamp.
	Seek(timestamp int64)
	// SeekFailed ends a seek operation started via GtkMediaStream.seek() as a
	// failure.
	SeekFailed()
	// SeekSuccess ends a seek operation started via GtkMediaStream.seek()
	// successfully.
	SeekSuccess()
	// SetLoop sets whether the stream should loop.
	SetLoop(loop bool)
	// SetMuted sets whether the audio stream should be muted.
	SetMuted(muted bool)
	// SetPlaying starts or pauses playback of the stream.
	SetPlaying(playing bool)
	// SetVolume sets the volume of the audio stream.
	SetVolume(volume float64)
	// Unprepared resets a given media stream implementation.
	Unprepared()
	// Unrealize undoes a previous call to gtk_media_stream_realize().
	Unrealize(surface gdk.Surfacer)
	// Update: media stream implementations should regularly call this function
	// to update the timestamp reported by the stream.
	Update(timestamp int64)
}

var _ MediaStreamer = (*MediaStream)(nil)

func wrapMediaStream(obj *externglib.Object) *MediaStream {
	return &MediaStream{
		Object: obj,
		Paintable: gdk.Paintable{
			Object: obj,
		},
	}
}

func marshalMediaStreamer(p uintptr) (interface{}, error) {
	val := C.g_value_get_object((*C.GValue)(unsafe.Pointer(p)))
	obj := externglib.Take(unsafe.Pointer(val))
	return wrapMediaStream(obj), nil
}

// Ended pauses the media stream and marks it as ended.
//
// This is a hint only, calls to GtkMediaStream.play() may still happen.
//
// The media stream must be prepared when this function is called.
func (self *MediaStream) Ended() {
	var _arg0 *C.GtkMediaStream // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	C.gtk_media_stream_ended(_arg0)
	runtime.KeepAlive(self)
}

// GError sets self into an error state.
//
// This will pause the stream (you can check for an error via
// gtk.MediaStream.GetError() in your GtkMediaStream.pause() implementation),
// abort pending seeks and mark the stream as prepared.
//
// if the stream is already in an error state, this call will be ignored and the
// existing error will be retained.
//
// To unset an error, the stream must be reset via a call to
// gtk.MediaStream.Unprepared().
func (self *MediaStream) GError(err error) {
	var _arg0 *C.GtkMediaStream // out
	var _arg1 *C.GError         // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))
	_arg1 = (*C.GError)(gerror.New(err))

	C.gtk_media_stream_gerror(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(err)
}

// Duration gets the duration of the stream.
//
// If the duration is not known, 0 will be returned.
func (self *MediaStream) Duration() int64 {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.gint64          // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_get_duration(_arg0)
	runtime.KeepAlive(self)

	var _gint64 int64 // out

	_gint64 = int64(_cret)

	return _gint64
}

// GetEnded returns whether the streams playback is finished.
func (self *MediaStream) GetEnded() bool {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.gboolean        // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_get_ended(_arg0)
	runtime.KeepAlive(self)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Error: if the stream is in an error state, returns the GError explaining that
// state.
//
// Any type of error can be reported here depending on the implementation of the
// media stream.
//
// A media stream in an error cannot be operated on, calls like
// gtk.MediaStream.Play() or gtk.MediaStream.Seek() will not have any effect.
//
// GtkMediaStream itself does not provide a way to unset an error, but
// implementations may provide options. For example, a gtk.MediaFile will unset
// errors when a new source is set, e.g. with gtk.MediaFile.SetFile().
func (self *MediaStream) Error() error {
	var _arg0 *C.GtkMediaStream // out
	var _cret *C.GError         // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_get_error(_arg0)
	runtime.KeepAlive(self)

	var _err error // out

	if _cret != nil {
		_err = gerror.Take(unsafe.Pointer(_cret))
	}

	return _err
}

// Loop returns whether the stream is set to loop.
//
// See gtk.MediaStream.SetLoop() for details.
func (self *MediaStream) Loop() bool {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.gboolean        // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_get_loop(_arg0)
	runtime.KeepAlive(self)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Muted returns whether the audio for the stream is muted.
//
// See gtk.MediaStream.SetMuted() for details.
func (self *MediaStream) Muted() bool {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.gboolean        // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_get_muted(_arg0)
	runtime.KeepAlive(self)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Playing: return whether the stream is currently playing.
func (self *MediaStream) Playing() bool {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.gboolean        // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_get_playing(_arg0)
	runtime.KeepAlive(self)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Timestamp returns the current presentation timestamp in microseconds.
func (self *MediaStream) Timestamp() int64 {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.gint64          // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_get_timestamp(_arg0)
	runtime.KeepAlive(self)

	var _gint64 int64 // out

	_gint64 = int64(_cret)

	return _gint64
}

// Volume returns the volume of the audio for the stream.
//
// See gtk.MediaStream.SetVolume() for details.
func (self *MediaStream) Volume() float64 {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.double          // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_get_volume(_arg0)
	runtime.KeepAlive(self)

	var _gdouble float64 // out

	_gdouble = float64(_cret)

	return _gdouble
}

// HasAudio returns whether the stream has audio.
func (self *MediaStream) HasAudio() bool {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.gboolean        // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_has_audio(_arg0)
	runtime.KeepAlive(self)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// HasVideo returns whether the stream has video.
func (self *MediaStream) HasVideo() bool {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.gboolean        // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_has_video(_arg0)
	runtime.KeepAlive(self)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsPrepared returns whether the stream has finished initializing.
//
// At this point the existence of audio and video is known.
func (self *MediaStream) IsPrepared() bool {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.gboolean        // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_is_prepared(_arg0)
	runtime.KeepAlive(self)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsSeekable checks if a stream may be seekable.
//
// This is meant to be a hint. Streams may not allow seeking even if this
// function returns TRUE. However, if this function returns FALSE, streams are
// guaranteed to not be seekable and user interfaces may hide controls that
// allow seeking.
//
// It is allowed to call gtk.MediaStream.Seek() on a non-seekable stream, though
// it will not do anything.
func (self *MediaStream) IsSeekable() bool {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.gboolean        // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_is_seekable(_arg0)
	runtime.KeepAlive(self)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// IsSeeking checks if there is currently a seek operation going on.
func (self *MediaStream) IsSeeking() bool {
	var _arg0 *C.GtkMediaStream // out
	var _cret C.gboolean        // in

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	_cret = C.gtk_media_stream_is_seeking(_arg0)
	runtime.KeepAlive(self)

	var _ok bool // out

	if _cret != 0 {
		_ok = true
	}

	return _ok
}

// Pause pauses playback of the stream.
//
// If the stream is not playing, do nothing.
func (self *MediaStream) Pause() {
	var _arg0 *C.GtkMediaStream // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	C.gtk_media_stream_pause(_arg0)
	runtime.KeepAlive(self)
}

// Play starts playing the stream.
//
// If the stream is in error or already playing, do nothing.
func (self *MediaStream) Play() {
	var _arg0 *C.GtkMediaStream // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	C.gtk_media_stream_play(_arg0)
	runtime.KeepAlive(self)
}

// Prepared: called by GtkMediaStream implementations to advertise the stream
// being ready to play and providing details about the stream.
//
// Note that the arguments are hints. If the stream implementation cannot
// determine the correct values, it is better to err on the side of caution and
// return TRUE. User interfaces will use those values to determine what controls
// to show.
//
// This function may not be called again until the stream has been reset via
// gtk.MediaStream.Unprepared().
func (self *MediaStream) Prepared(hasAudio bool, hasVideo bool, seekable bool, duration int64) {
	var _arg0 *C.GtkMediaStream // out
	var _arg1 C.gboolean        // out
	var _arg2 C.gboolean        // out
	var _arg3 C.gboolean        // out
	var _arg4 C.gint64          // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))
	if hasAudio {
		_arg1 = C.TRUE
	}
	if hasVideo {
		_arg2 = C.TRUE
	}
	if seekable {
		_arg3 = C.TRUE
	}
	_arg4 = C.gint64(duration)

	C.gtk_media_stream_prepared(_arg0, _arg1, _arg2, _arg3, _arg4)
	runtime.KeepAlive(self)
	runtime.KeepAlive(hasAudio)
	runtime.KeepAlive(hasVideo)
	runtime.KeepAlive(seekable)
	runtime.KeepAlive(duration)
}

// Realize: called by users to attach the media stream to a GdkSurface they
// manage.
//
// The stream can then access the resources of surface for its rendering
// purposes. In particular, media streams might want to create a GdkGLContext or
// sync to the GdkFrameClock.
//
// Whoever calls this function is responsible for calling
// gtk.MediaStream.Unrealize() before either the stream or surface get
// destroyed.
//
// Multiple calls to this function may happen from different users of the video,
// even with the same surface. Each of these calls must be followed by its own
// call to gtk.MediaStream.Unrealize().
//
// It is not required to call this function to make a media stream work.
func (self *MediaStream) Realize(surface gdk.Surfacer) {
	var _arg0 *C.GtkMediaStream // out
	var _arg1 *C.GdkSurface     // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))
	_arg1 = (*C.GdkSurface)(unsafe.Pointer(surface.Native()))

	C.gtk_media_stream_realize(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(surface)
}

// Seek: start a seek operation on self to timestamp.
//
// If timestamp is out of range, it will be clamped.
//
// Seek operations may not finish instantly. While a seek operation is in
// process, the gtk.MediaStream:seeking property will be set.
//
// When calling gtk_media_stream_seek() during an ongoing seek operation, the
// new seek will override any pending seek.
func (self *MediaStream) Seek(timestamp int64) {
	var _arg0 *C.GtkMediaStream // out
	var _arg1 C.gint64          // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))
	_arg1 = C.gint64(timestamp)

	C.gtk_media_stream_seek(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(timestamp)
}

// SeekFailed ends a seek operation started via GtkMediaStream.seek() as a
// failure.
//
// This will not cause an error on the stream and will assume that playback
// continues as if no seek had happened.
//
// See gtk.MediaStream.SeekSuccess() for the other way of ending a seek.
func (self *MediaStream) SeekFailed() {
	var _arg0 *C.GtkMediaStream // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	C.gtk_media_stream_seek_failed(_arg0)
	runtime.KeepAlive(self)
}

// SeekSuccess ends a seek operation started via GtkMediaStream.seek()
// successfully.
//
// This function will unset the GtkMediaStream:ended property if it was set.
//
// See gtk.MediaStream.SeekFailed() for the other way of ending a seek.
func (self *MediaStream) SeekSuccess() {
	var _arg0 *C.GtkMediaStream // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	C.gtk_media_stream_seek_success(_arg0)
	runtime.KeepAlive(self)
}

// SetLoop sets whether the stream should loop.
//
// In this case, it will attempt to restart playback from the beginning instead
// of stopping at the end.
//
// Not all streams may support looping, in particular non-seekable streams.
// Those streams will ignore the loop setting and just end.
func (self *MediaStream) SetLoop(loop bool) {
	var _arg0 *C.GtkMediaStream // out
	var _arg1 C.gboolean        // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))
	if loop {
		_arg1 = C.TRUE
	}

	C.gtk_media_stream_set_loop(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(loop)
}

// SetMuted sets whether the audio stream should be muted.
//
// Muting a stream will cause no audio to be played, but it does not modify the
// volume. This means that muting and then unmuting the stream will restore the
// volume settings.
//
// If the stream has no audio, calling this function will still work but it will
// not have an audible effect.
func (self *MediaStream) SetMuted(muted bool) {
	var _arg0 *C.GtkMediaStream // out
	var _arg1 C.gboolean        // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))
	if muted {
		_arg1 = C.TRUE
	}

	C.gtk_media_stream_set_muted(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(muted)
}

// SetPlaying starts or pauses playback of the stream.
func (self *MediaStream) SetPlaying(playing bool) {
	var _arg0 *C.GtkMediaStream // out
	var _arg1 C.gboolean        // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))
	if playing {
		_arg1 = C.TRUE
	}

	C.gtk_media_stream_set_playing(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(playing)
}

// SetVolume sets the volume of the audio stream.
//
// This function call will work even if the stream is muted.
//
// The given volume should range from 0.0 for silence to 1.0 for as loud as
// possible. Values outside of this range will be clamped to the nearest value.
//
// If the stream has no audio or is muted, calling this function will still work
// but it will not have an immediate audible effect. When the stream is unmuted,
// the new volume setting will take effect.
func (self *MediaStream) SetVolume(volume float64) {
	var _arg0 *C.GtkMediaStream // out
	var _arg1 C.double          // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))
	_arg1 = C.double(volume)

	C.gtk_media_stream_set_volume(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(volume)
}

// Unprepared resets a given media stream implementation.
//
// gtk.MediaStream.Prepared() can then be called again.
//
// This function will also reset any error state the stream was in.
func (self *MediaStream) Unprepared() {
	var _arg0 *C.GtkMediaStream // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))

	C.gtk_media_stream_unprepared(_arg0)
	runtime.KeepAlive(self)
}

// Unrealize undoes a previous call to gtk_media_stream_realize().
//
// This causes the stream to release all resources it had allocated from
// surface.
func (self *MediaStream) Unrealize(surface gdk.Surfacer) {
	var _arg0 *C.GtkMediaStream // out
	var _arg1 *C.GdkSurface     // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))
	_arg1 = (*C.GdkSurface)(unsafe.Pointer(surface.Native()))

	C.gtk_media_stream_unrealize(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(surface)
}

// Update: media stream implementations should regularly call this function to
// update the timestamp reported by the stream.
//
// It is up to implementations to call this at the frequency they deem
// appropriate.
//
// The media stream must be prepared when this function is called.
func (self *MediaStream) Update(timestamp int64) {
	var _arg0 *C.GtkMediaStream // out
	var _arg1 C.gint64          // out

	_arg0 = (*C.GtkMediaStream)(unsafe.Pointer(self.Native()))
	_arg1 = C.gint64(timestamp)

	C.gtk_media_stream_update(_arg0, _arg1)
	runtime.KeepAlive(self)
	runtime.KeepAlive(timestamp)
}
